<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
<title>Freghar's Gitlog - The wonderful world of Git</title>
</head>


<body>

<h1>The wonderful world of Git</h1>
<p>Ladies and gentlemen, please let me announce an initial chapter of my small tutorial about Git.<br />
I won't write here about things that are well documented elsewhere (like merge, clone, etc.), I want to point out several things that aren't done the "right way" instead. Things that are common in git user's life without his knowledge. Things that make Git so superior to other Source Control Management systems (SCMs) and things some of you will find so cool, that you won't ever want to use SVN again.</p>
<p>A little note; I'm NOT saying Git is the best tool for everyone, that SVN is the worst SCM you can get, that people who don't want to learn git are noobs, ..., I'm just trying here to get things straight, to show some things why I use git instead of SVN, to let you explore them as well.</p>
<p>In this first chapter, I'm going to say a few words about myths that born since the switch and add some links for you.</p>
<hr />
<br />

<h2>First myth - Git isn't user friendly</h2>
<p>That depends. Some people prefer command line, some graphical interfaces. No program is user-friendly if you don't know it. Yes, there are automatic intuitive GUIs, like many Windows (and most graphical *nix) programs have, which will guide you through setups, configurations and other stuff. This kind of approach isn't "the only good one" from (not only) my point of view.</p>
<p>When a total computer newbie receives a Personal Computer case and can't turn it on by pushing the only one button, he may enter three states:</p>
<ol>
<li>He says that the product is f*cked, that's so hard to use it, because nobody told him a single word, nobody introduced him to such things and throws the case through the window.</li>
<li>He may try to figure out why it's not working and after some time, he tries to plug it in. The computer is running now, but that's all, can't use it. Right, so we have this plug here and that cable over there, ah, a display, keyboard, ..., but what the hell is "No operating system found"? Can't resolve it with random pressing keys on the keyboard.</li>
<li>He tries to read the manual, so he learns something about Operating Systems, how to install and use them.</li>
</ol>
<p>Git, as many other (not only) console tools in fact, requies 3rd way of solving things; reading the manual before using something. So it IS user-friendly, but you can't expect it to automatically teach you ...</p>
<br />

<h2>Second myth - Git is Linux-only, with very bad support for Windows</h2>
<p>As the first myth, this is not true either. Support in Microsoft Windows is not that good as on *nix, but not that bad either. Msysgit uses cygwin environment with many tools like GNU patch, grep, sed, ..., which you can use for string processing just like on *nix. The Msysgit, however, does not contain git-svn for example, git-cvsserver and other external tools, which can be installed, but it's not that easy as on most Linux distributions.</p>
<p>Commands are the same everywhere, so the git core system is as hard/easy as everywhere else. Plus, there's a tortoisegit project in development.</p>
<br />

<h2>Third myth - Git is only for developers</h2>
<p>Am I the official developer of Mangos? Nope. Do I understand Git? Answer for yourselves. Actually, I'm a C developer, I don't care much about C++, so I can help here with general C things, code cleanups, simple fixes, ... and possibly development management. But I'm no big C++ developer and I still use Git. My friend doesn't know any programming language besides bash shell scripting, but he also uses Git just to get my stuff ... so where's the truth?</p>
<br />

<h2>Four myth - it has no revision tracking</h2>
<p>This is the most discussed problem here. It is true, that it has no svn-like revisions, just for logical reasons - it's distributed. Let me quote myself again:</p>
<blockquote>
Actually, you probably didn't understand why it is a hash instead of numeric revision, did you? An example -- "my r344 is Bob's 233 and Alice's 81" , "hey Bob, make a diff from the r80 to r81" "that's not from r80, that's r45!".
</blockquote>
<p>That's why Git uses unique hashes. If you want something that can be refered to as a global incrementing value, use date and time, it's that simple. So it HAS some tracking, but not the SVN-like one.</p>
<br />

<h2>Fifth myth - it was chosen only because of SVN network problems</h2>
<p>As far as I know, this is not true. If I understood correctly TheLuda's PMs in May 2008, he wanted to create a new git+svn system (based on Ruby?) with issue tracking and mangos-related project hosting (?). The lack of SVN traffic is (I believe) ONE of the reasons. Again, I will quote myself:</p>
<blockquote>
In fact, Git gives you a tons of freedom, source control management representation of open-source. You can actually see it even now -- <a href="http://github.com/mangos/mangos/network">http://github.com/mangos/mangos/network</a> -- people are forking it and doing custom stuff, I believe this is the way TheLuda meant it. If you have an SVN, you can develop things, but you can either have them in dirty working trees or on your own SVN (which isn't much of a problem now, thanks to assembla &amp; others), however you can never reach the distributed development style as it's possible to do with an decentralized SCM ...
</blockquote>
<blockquote>
"SVN is more simple, why use GIT?" The answer is not only in bandwidth (as you can do diffs offline, etc), but in something else. Most of you lack the knowledge of what Git is able to do over SVN. Yeah, you have no damned idea what's possible with it because you can't imagine it now (still trying to compare it with SVN, eh?).

And I say it again - you have NO idea. I can promise you that if Mangos will take full advantage of what's Git possible to do, there would be no SVN mirror, just because you can't mirror all those constantly changing and temporary branches and tags (and several versions) effectively to SVN, not to mention octopus merges.

And if that happen, you won't ever want SVN back, not even the most dumb users.
</blockquote>
<br />

<p>And that's all for the myths I can recall.</p>
<hr />
<br />

<p>Let's head for the second part - useful links and Git documentation.</p>
<p>I've written a set of steps some time ago, let's show it here again:</p>
<ol>
<li><a href="http://www.youtube.com/watch?v=4XpnKHJAok8">http://www.youtube.com/watch?v=4XpnKHJAok8</a> (Linus' talk about the philosophy of Git)</li>
<li><a href="http://www.youtube.com/watch?v=8dhZ9BXQgc4">http://www.youtube.com/watch?v=8dhZ9BXQgc4</a> (Randal's practical examples)</li>
<li>do some tests in a test repo</li>
<li>(google.com-ed sites) <a href="http://cworth.org/hgbook-git/tour/">http://cworth.org/hgbook-git/tour/</a></li>
<li><a href="http://www.kernel.org/pub/software/scm/git/docs/">http://www.kernel.org/pub/software/scm/git/docs/</a> (user manuals for various Git versions)</li>
<li>explore things a little bit</li>
<li><a href="http://eagain.net/articles/git-for-computer-scientists/">http://eagain.net/articles/git-for-computer-scientists/</a> (stuff about objects - very important for more experienced users)</li>
<li>do even more tests, experiment with objects, dangling objects, things like interactive adding of code parts, interactive rebase, git-send-email, ...</li>
<li>...</li>
<li>...</li>
<li>...</li>
<li>#git on freenode</li>
</ol>

<p>Well you can use other docs as a reference, for example links on the GitWiki -</p>
<ul>
<li><a href="http://jonas.iki.fi/git_guides/HTML/git_guide/">http://jonas.iki.fi/git_guides/HTML/git_guide/</a></li>
<li><a href="http://git.or.cz/gitwiki/CategoryGitDocumentation">http://git.or.cz/gitwiki/CategoryGitDocumentation</a></li>
<li>...</li>
<li><a href="http://book.git-scm.com/">http://book.git-scm.com/</a> (Git SCM book)</li>
<li><a href="http://www.gitcasts.com/episodes">http://www.gitcasts.com/episodes</a> (screencasts related to it)</li>
<li><a href="http://www-cs-students.stanford.edu/~blynn/gitmagic/index.html">http://www-cs-students.stanford.edu/~blynn/gitmagic/index.html</a> (lots of pointers)</li>
<li><a href="http://excess.org/article/2008/07/ogre-git-tutorial/">http://excess.org/article/2008/07/ogre-git-tutorial/</a> (another "Git the basics" video, by Bart Trojanowski)</li>
<li><a href="http://www.youtube.com/watch?v=j45cs5_nY2k">http://www.youtube.com/watch?v=j45cs5_nY2k</a> ("Contributing with Git" by Johannes Schindelin)</li>
<li><a href="http://gitready.com/">http://gitready.com/</a> (daily tasks with Git, divided into categories by "knowledge levels")</li>
<li>(just google them out)</li>
</ul>

<p>So that's all for the first chapter, I wanted to write here something about resizing the git-bash window in MS Windows, but I guess most users can figure it out (right click on the window on taskbar -&gt; properties and change 80x25 to something wider), about VIm editor basics (it's used by default for commit message editing and all the stuff - <a href="http://www.vi-improved.org/tutorial.php">http://www.vi-improved.org/tutorial.php</a>), but I'll cut it short.</p>

<p>PS: Don't fear new things :)</p>

<p>Freghar</p>

</body>


</html>
